/*
	Special protocol security services by Catid@pacbell.net
	-------------------------------------------------------
	This library implements all the SubSpace core protocol
	features in complete safety from exploitation, use only
	in combination with <host.h>
*/

#ifndef SPECIALPROT_H
#define SPECIALPROT_H

#include "host.h"

void handleSpecialHeader(hostMessage * msg);	// 00 "Request some of the core protocol"


void handleEncryptRequest(hostMessage * msg);	// 01 <Client key(4)> <Protocol version(2)>
void handleEncryptResponse(hostMessage * msg);	// 02 <Session encryption key(4)> [Continuum mudge(1)]
void handleDisconnect(hostMessage * msg);		// 07 "Session termination"


void handleReliable(hostMessage * msg);			// 03 <ACK_ID(4)> <Message(...)>
void handleACK(hostMessage * msg);				// 04 <ACK_ID(4)>


void handleSyncRequest(hostMessage * msg);		// 05 <Client time1(4)> [Total packets sent(4)] [Total packets recv'd(4)]
void handleSyncResponse(hostMessage * msg);		// 06 <Server time(4)> <Client time1(4)>


void handleChunkBody(hostMessage * msg);		// 08 <Message chunk(...)>
void handleChunkTail(hostMessage * msg);		// 09 <Message chunk(...)> "Process accumulated buffer as a message"

void handleBigChunk(hostMessage * msg);			// 0A <Total length(4)> <Message chunk(...)> "Buffer contains up to 20 MB"

void handleCluster(hostMessage * msg);			// 0E <Message length(1)> <Message(...)> "Carpool into one packet"

#endif	// SPECIALPROT_H
